/******************语音模块通信数据库****************/
/******************IO定义****************************/
int IO_JQ8X00_BusyCheck = 4;                                //语音模块报告“设备正忙状态”IO
/*（若您的语音模块没有单独的/busy引脚，请将IO口分配到不存在的引脚999上） */

/******************全局变量**************************/
int JQ8X00_BusyCheck = 0;                                   //是否启用忙检测 0表示不做忙检测，1表做忙检测


/******************串口控制**************************/
typedef enum
{
  RESET                             = 0xAA,                 /*串口通信起始码，单发此指令为重置串口缓存*/
  CheckPlayState                    = 0x01,                 /*查询播报状态*/
    
    Play                            = 0x02,                 /*播放*/
    pause                           = 0x03,                 /*暂停*/
    Stop                            = 0x04,                 /*停止*/
    LastSong                        = 0x05,                 /*上一曲*/
    NextSong                        = 0x06,                 /*下一曲*/
    EndPlay                         = 0x10,                 /*播放完当前曲目后停止*/

    CheckOnelineDisksign            = 0x09,                 /*查询当前在线盘符*/
    CheckCurrentDisksign            = 0X0A,                 /*查询当前播放盘符*/
    CheckTotalTrack                 = 0x0C,                 /*查询总曲目*/
    CurrentTrack                    = 0x0D,                 /*当前曲目*/

    LastFloder                      = 0x0E,                 /*上一个文件夹目录*/
    NextFloder                      = 0x0F,                 /*下一个文件夹目录*/
    

    CheckFloderFirstTrack           = 0x11,                 /*查询文件目录首曲目*/
    CheckFloderAllTrack             = 0x12,                 /*查询文件目录总曲目*/
    
    AddVolume                       = 0x14,                 /*音量加*/
    DecVolume                       = 0x15,                 /*音量减*/
    
    EndZHPlay                       = 0X1C,                 /*结束组合播报*/
    CheckSongShortName              = 0x1E,                 /*查询歌曲短文件名*/
    EndLoop                         = 0x21,                 /*结束复读*/
    
    GetTotalSongTime                = 0x24,                 /*获取当前曲目总时间*/
    OpenPlayTime                    = 0x25,                 /*播放时间开发送*/
    ClosePlayTime                   = 0x26,                 /*关闭播放时间发送*/
} 
UartCommand;                                                //后面无附加数据的指令，
                                                            //指令发送格式为 起始码-指令类型-数据长度-校验和

typedef enum
{
    AppointTrack                    = 0x07,                 /*指定曲目播放*/
  /*在后面输入要播放的曲目编号即可播放，
   *文件编号顺序按照写入存储介质先后顺序排列，
   *例如先复制03.MP3后复制01.mp3，选择01号曲目会播放03.mp3*/
    SetCycleCount                   = 0x19,                 /*设置循环次数*/
  /*在后面输入循环次数，循环模式下循环次数为无限次*/
    SetEQ                           = 0X1A,                 /*EQ设置*/
  /*更改音频输出的均匀器效果，后面可接“EQModeSelect”其中一个指令*/
    SelectTrackNoPlay               = 0x1F,                 /*选曲不播放*/
  /*在后面输入要播放的曲目编号之后下一首播放*/
    GoToDisksign                    = 0X0B,                 /*切换播放存储介质*/
  /*请从后续“JQ8X00_Symbol”选择你需要切换的存储介质*/
    SetVolume                       = 0x13,                 /*音量设置*/
  /*可设置0~30点音量，开机状况下默认音量30*/
    SetLoopMode                     = 0x18,                 /*设置循环模式*/
  /*更改音乐播放的循环模式，后面可接“LoopModeSelect”其中一个指令*/
    SetChannel                      = 0x1D,                 /*设置通道*/
  /*0为MP3，1为AUX，2为MP3和AUX混音*/
    AppointTimeBack                 = 0x22,                 /*指定时间快退*/
    AppointTimeFast                 = 0x23,                 /*指定时间快退*/
  /*后面参数单位均为秒*/
}
UartCommandData;                                            //包含附加数据的指令，
                                                            //指令发送格式为 起始码-指令类型-数据长度-数据1-数据2-...-数据N-校验和

typedef enum {
    Normal                          = 0X00,                 /*标准    均匀器预设*/
    Pop                             = 0x01,                 /*流行音乐  均匀器预设*/
    Rock                            = 0x02,                 /*摇滚音乐  均匀器预设*/
    Jazz                            = 0X03,                 /*爵士音乐  均匀器预设*/
    Classic                         = 0X04,                 /*古典音乐  均匀器预设*/
}
EQModeSelect;                                               //均匀器预设选择   对应“SetEQ”

typedef enum {
    OverallCycle                    = 0X00,                 /*全盘循环 按顺序播放全盘曲目,播放完后循环播放*/
    SingleCycle                     = 0x01,                 /*单曲循环 一直循环播放当前曲目*/
    SingleStop                      = 0x02,                 /*单曲停止 播放完当前曲目一次停止*/
    OverallRandom                   = 0X03,                 /*全盘随机 随机播放盘符内曲目*/
    CatalogCycle                    = 0X04,                 /*目录循环 按顺序播放当前文件夹内曲目,播放完后循环播放，目录不包含子目录*/
    CatalogRandom                   = 0x05,                 /*目录随机 在当前目录内随机播放，目录不包含子目录*/
    CatalogTurnPlay                 = 0x06,                 /*目录顺序播放 按顺序播放当前文件夹内曲目,播放完后停止，目录不包含子目录*/
    OverallTurnPlay                 = 0x07,                 /*全盘顺序播放 按顺序播放全盘曲目,播放完后停止*/ 
}
LoopModeSelect;                                             //循环模式选择      对应“SetLoopMode”

typedef enum{
    JQ8X00_USB                      = 0X00,                 /*选择存储介质为 U盘*/
    JQ8X00_SD                       = 0x01,                 /*选择存储介质为 SD*/
    JQ8X00_FLASH                    = 0x02,                 /*选择存储介质为 与芯片联通的eMMC存储模块*/
}
JQ8X00_Symbol;                                              //切换播放存储介质编号  对应“GoToDisksign”


/******************函数定义区**************************/

/************************************************************************
  功能描述：起始码-指令类型-数据长度-校验和
  入口参数：   MODE：模式
  返 回 值： none
  其他说明： 不带数据的指令播放函数.无数数据传入
**************************************************************************/
void  JQ8x00_Command(UartCommand Command)
{
    u8 Buffer[4] = {0xaa};

    Buffer[1] = Command;                                    //指令类型
    Buffer[2] = 0x00;                                       //数据长度为0
    Buffer[3] = Buffer[0] +  Buffer[1] +  Buffer[2];        //校验和

    if (JQ8X00_BusyCheck)
    {
        delay(10);
        while (digitalRead(IO_JQ8X00_BusyCheck) == HIGH);   //等待语音模块取消“设备正忙”状态
    }
    Serial.write(Buffer, 4);
}

/************************************************************************
  功能描述：起始码-指令类型-数据长度-数据-校验和
  入口参数：   *DAT：字符串指针,Len字符串长度
  返 回 值： none
  其他说明：
**************************************************************************/
void  JQ8x00_Command_Data(UartCommandData Command, u8 DATA)
{
    u8 Buffer[6] = {0xaa};
    u8 DataLen = 0;                                         //数据长度
    Buffer[1] = Command;                                    //指令类型
    if((Command != AppointTrack) && (Command != SetCycleCount) && (Command != SelectTrackNoPlay) && (Command != AppointTimeBack) && (Command != AppointTimeFast))        
                                                            //若待发送指令为只含一个数据的指令
    {
        Buffer[2] = 1;                                      //数据长度为1
        Buffer[3] = DATA;                                   //附加数据
        Buffer[4] = Buffer[0] +  Buffer[1] +  Buffer[2] + Buffer[3];
                                                            //校验和
        DataLen = 5;
    }
    else                                                    //若待发送指令为不止一个数据的指令
  {
        Buffer[2] = 2;                                      //数据长度为2
        Buffer[3] = DATA/256;                               //数据1
        Buffer[4] = DATA%256;                               //数据2
        Buffer[5] = Buffer[0] +  Buffer[1] +  Buffer[2] + Buffer[3] + Buffer[4];
                                                            //校验和
        DataLen = 6;
    }

    if (JQ8X00_BusyCheck)
    {
        delay(10);
        while (digitalRead(IO_JQ8X00_BusyCheck) == HIGH);   //等待语音模块取消“设备正忙”状态
    }
    Serial.write(Buffer, DataLen);                          //打包发送数据长度为DataLen的一组指令集
}

/************************************************************************
  功能描述：播放根目录指定文件名的音频文件
  入口参数：JQ8X00_Symbol:系统盘符，*DATA:需要播放的文件名
  返 回 值： none
  其他说明：播放FLASH根目录下文件名为00001.mp3的音频，JQ_8x00_AppointPlay(JQ8X00_FLASH,"00001");
**************************************************************************/
void JQ8x00_AppointPlay(JQ8X00_Symbol MODE, char *DATA)
{
    u8 Buffer[30] = {0xaa, 0x08};
    u8 i, j;
    Buffer[2] = 1 + strlen(DATA) + 5;                       //数据长度
    Buffer[3] = MODE;                                       //盘符
    Buffer[4] = '/';                                        //路径
    i = 5;
    while (*DATA)
    {
        Buffer[i++] =  *DATA;
        DATA++;
    }
    Buffer[i++] = '*';
    Buffer[i++] = '?';
    Buffer[i++] = '?';
    Buffer[i++] = '?';                                      //根据解析ANSI结果发送HEX数据
    for (j = 0; j < i; j++)
    {
        Buffer[i] = Buffer[i] + Buffer[j];                  //最后发送校验和
    }
    i++;

    if (JQ8X00_BusyCheck)
    {
        delay(10);
        while (digitalRead(IO_JQ8X00_BusyCheck) == HIGH);   //等待语音模块取消“设备正忙”状态
    }

    Serial.write(Buffer, i);                                //打包发送数据长度为i的一组指令集
}

/************************************************************************
  功能描述：组合播放函数
  入口参数：   *DAT：字符串指针,Len字符串长度
  返 回 值： none
  其他说明： 将需要播报的文件名放入数组中作为形参即可,例：组合播放01,02文件，则DATA内容为{1,2}，JQ8x00_ZuHeBoFang（DATA，2）
**************************************************************************/
void  JQ8x00_ZuHeBoFang(unsigned char *DATA, unsigned char Len)
{
    unsigned char CRC_data = 0, i = 3;
    unsigned char Buffer[30] = {0xaa, 0x1b};

    Buffer[2] = Len * 2;                                    //计算长度
    CRC_data = CRC_data + 0xaa + 0x1b + Buffer[2];
    while (Len--)
    {
        Buffer[i] = *DATA / 10 + 0x30;                      //取出十位
        CRC_data = CRC_data + Buffer[i];
        i++;
        Buffer[i] = *DATA % 10 + 0x30;                      //取出个位
        CRC_data = CRC_data + Buffer[i];
        i++;
        DATA++;
    }
    Buffer[i] = CRC_data;
    i++;
    if (JQ8X00_BusyCheck)
    {
        delay(10);
        while (digitalRead(IO_JQ8X00_BusyCheck) == HIGH);   //等待语音模块取消“设备正忙”状态
    }

    Serial.write(Buffer, i);                                //打包发送数据长度为i的一组指令集
  }

/***************语音模块通信数据库已结束*************/
/*数据库已由“语音芯片模块技术交流群JQ8400/JQ8900/JR6001系列” @空白 推送更新并在2019年10月18日12:54:35应用*/
/*注释补充和预设指令表由李皇谛·李炜于2019年10月19日13:12:57完善*/
/********************应用例如下********************/
void setup(){                                               //Arduino的初始化程序，开机后只执行一次
  if (JQ8X00_BusyCheck){
    pinMode(IO_JQ8X00_BusyCheck, INPUT_PULLUP);             //忙检测引脚初始化
    }
    Serial.begin(9600,SERIAL_8N1);                          //启动串口，通信频率为9600Hz，数据包长度为8，无校验位，占用1个停止位
    delay(10);                                              //延时10ms，防止串口数据包被中断
    JQ8x00_Command_Data(SetVolume, 30);                     //设置音量为30
    delay(10);                                              //延时10ms
   JQ8x00_Command_Data(AppointTrack,2);                     //播放指定曲目2
   JQ8x00_AppointPlay(JQ8X00_FLASH, "00002");               //播放FLASH下，文件名为00002的音频文件
   
}
void loop(){                                                //Arduino的循环程序，初始化程序完成后重复执行
}
/*********************接线方法**********************
连接Arduino的RXD0到语音模块的TXD，
连接Arduino的TXD1到语音模块的RXD，
注意Arduino的地线与语音模块的地线需要连通以比对参考等同的零电位
**************************************************/
